Index: uspace/srv/bd/file_bd/file_bd.c
===================================================================
--- uspace/srv/bd/file_bd/file_bd.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/bd/file_bd/file_bd.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -48,9 +48,7 @@
 #include <stdint.h>
 #include <errno.h>
-#include <str_error.h>
 #include <stdbool.h>
 #include <task.h>
 #include <macros.h>
-#include <str.h>
 
 #define NAME "file_bd"
@@ -67,13 +65,13 @@
 
 static void print_usage(void);
-static errno_t file_bd_init(const char *fname);
+static int file_bd_init(const char *fname);
 static void file_bd_connection(ipc_callid_t iid, ipc_call_t *icall, void *);
 
-static errno_t file_bd_open(bd_srvs_t *, bd_srv_t *);
-static errno_t file_bd_close(bd_srv_t *);
-static errno_t file_bd_read_blocks(bd_srv_t *, aoff64_t, size_t, void *, size_t);
-static errno_t file_bd_write_blocks(bd_srv_t *, aoff64_t, size_t, const void *, size_t);
-static errno_t file_bd_get_block_size(bd_srv_t *, size_t *);
-static errno_t file_bd_get_num_blocks(bd_srv_t *, aoff64_t *);
+static int file_bd_open(bd_srvs_t *, bd_srv_t *);
+static int file_bd_close(bd_srv_t *);
+static int file_bd_read_blocks(bd_srv_t *, aoff64_t, size_t, void *, size_t);
+static int file_bd_write_blocks(bd_srv_t *, aoff64_t, size_t, const void *, size_t);
+static int file_bd_get_block_size(bd_srv_t *, size_t *);
+static int file_bd_get_num_blocks(bd_srv_t *, aoff64_t *);
 
 static bd_ops_t file_bd_ops = {
@@ -88,5 +86,5 @@
 int main(int argc, char **argv)
 {
-	errno_t rc;
+	int rc;
 	char *image_name;
 	char *device_name;
@@ -136,6 +134,6 @@
 	rc = loc_service_register(device_name, &service_id);
 	if (rc != EOK) {
-		printf("%s: Unable to register device '%s': %s.\n",
-		    NAME, device_name, str_error(rc));
+		printf("%s: Unable to register device '%s'.\n",
+		    NAME, device_name);
 		return rc;
 	}
@@ -143,5 +141,5 @@
 	rc = loc_category_get_id("disk", &disk_cat, IPC_FLAG_BLOCKING);
 	if (rc != EOK) {
-		printf("%s: Failed resolving category 'disk': %s\n", NAME, str_error(rc));
+		printf("%s: Failed resolving category 'disk'.\n", NAME);
 		return rc;
 	}
@@ -149,6 +147,6 @@
 	rc = loc_service_add_to_cat(service_id, disk_cat);
 	if (rc != EOK) {
-		printf("%s: Failed adding %s to category: %s",
-		    NAME, device_name, str_error(rc));
+		printf("%s: Failed adding %s to category.",
+		    NAME, device_name);
 		return rc;
 	}
@@ -167,5 +165,5 @@
 }
 
-static errno_t file_bd_init(const char *fname)
+static int file_bd_init(const char *fname)
 {
 	bd_srvs_init(&bd_srvs);
@@ -173,5 +171,5 @@
 	
 	async_set_fallback_port_handler(file_bd_connection, NULL);
-	errno_t rc = loc_server_register(NAME);
+	int rc = loc_server_register(NAME);
 	if (rc != EOK) {
 		printf("%s: Unable to register driver.\n", NAME);
@@ -207,5 +205,5 @@
 
 /** Open device. */
-static errno_t file_bd_open(bd_srvs_t *bds, bd_srv_t *bd)
+static int file_bd_open(bd_srvs_t *bds, bd_srv_t *bd)
 {
 	return EOK;
@@ -213,5 +211,5 @@
 
 /** Close device. */
-static errno_t file_bd_close(bd_srv_t *bd)
+static int file_bd_close(bd_srv_t *bd)
 {
 	return EOK;
@@ -219,8 +217,9 @@
 
 /** Read blocks from the device. */
-static errno_t file_bd_read_blocks(bd_srv_t *bd, uint64_t ba, size_t cnt, void *buf,
+static int file_bd_read_blocks(bd_srv_t *bd, uint64_t ba, size_t cnt, void *buf,
     size_t size)
 {
 	size_t n_rd;
+	int rc;
 
 	if (size < cnt * block_size)
@@ -238,5 +237,6 @@
 
 	clearerr(img);
-	if (fseek(img, ba * block_size, SEEK_SET) < 0) {
+	rc = fseek(img, ba * block_size, SEEK_SET);
+	if (rc < 0) {
 		fibril_mutex_unlock(&dev_lock);
 		return EIO;
@@ -259,8 +259,9 @@
 
 /** Write blocks to the device. */
-static errno_t file_bd_write_blocks(bd_srv_t *bd, uint64_t ba, size_t cnt,
+static int file_bd_write_blocks(bd_srv_t *bd, uint64_t ba, size_t cnt,
     const void *buf, size_t size)
 {
 	size_t n_wr;
+	int rc;
 
 	if (size < cnt * block_size)
@@ -278,5 +279,6 @@
 
 	clearerr(img);
-	if (fseek(img, ba * block_size, SEEK_SET) < 0) {
+	rc = fseek(img, ba * block_size, SEEK_SET);
+	if (rc < 0) {
 		fibril_mutex_unlock(&dev_lock);
 		return EIO;
@@ -301,5 +303,5 @@
 
 /** Get device block size. */
-static errno_t file_bd_get_block_size(bd_srv_t *bd, size_t *rsize)
+static int file_bd_get_block_size(bd_srv_t *bd, size_t *rsize)
 {
 	*rsize = block_size;
@@ -308,5 +310,5 @@
 
 /** Get number of blocks on device. */
-static errno_t file_bd_get_num_blocks(bd_srv_t *bd, aoff64_t *rnb)
+static int file_bd_get_num_blocks(bd_srv_t *bd, aoff64_t *rnb)
 {
 	*rnb = num_blocks;
Index: uspace/srv/bd/rd/rd.c
===================================================================
--- uspace/srv/bd/rd/rd.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/bd/rd/rd.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -48,5 +48,4 @@
 #include <stdbool.h>
 #include <errno.h>
-#include <str_error.h>
 #include <async.h>
 #include <fibril_synch.h>
@@ -67,10 +66,10 @@
 static const size_t block_size = 512;
 
-static errno_t rd_open(bd_srvs_t *, bd_srv_t *);
-static errno_t rd_close(bd_srv_t *);
-static errno_t rd_read_blocks(bd_srv_t *, aoff64_t, size_t, void *, size_t);
-static errno_t rd_write_blocks(bd_srv_t *, aoff64_t, size_t, const void *, size_t);
-static errno_t rd_get_block_size(bd_srv_t *, size_t *);
-static errno_t rd_get_num_blocks(bd_srv_t *, aoff64_t *);
+static int rd_open(bd_srvs_t *, bd_srv_t *);
+static int rd_close(bd_srv_t *);
+static int rd_read_blocks(bd_srv_t *, aoff64_t, size_t, void *, size_t);
+static int rd_write_blocks(bd_srv_t *, aoff64_t, size_t, const void *, size_t);
+static int rd_get_block_size(bd_srv_t *, size_t *);
+static int rd_get_num_blocks(bd_srv_t *, aoff64_t *);
 
 /** This rwlock protects the ramdisk's data.
@@ -100,5 +99,5 @@
 
 /** Open device. */
-static errno_t rd_open(bd_srvs_t *bds, bd_srv_t *bd)
+static int rd_open(bd_srvs_t *bds, bd_srv_t *bd)
 {
 	return EOK;
@@ -106,5 +105,5 @@
 
 /** Close device. */
-static errno_t rd_close(bd_srv_t *bd)
+static int rd_close(bd_srv_t *bd)
 {
 	return EOK;
@@ -112,5 +111,5 @@
 
 /** Read blocks from the device. */
-static errno_t rd_read_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt, void *buf,
+static int rd_read_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt, void *buf,
     size_t size)
 {
@@ -128,5 +127,5 @@
 
 /** Write blocks to the device. */
-static errno_t rd_write_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt,
+static int rd_write_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt,
     const void *buf, size_t size)
 {
@@ -147,5 +146,5 @@
 {
 	sysarg_t size;
-	errno_t ret = sysinfo_get_value("rd.size", &size);
+	int ret = sysinfo_get_value("rd.size", &size);
 	if ((ret != EOK) || (size == 0)) {
 		printf("%s: No RAM disk found\n", NAME);
@@ -180,5 +179,5 @@
 	ret = loc_server_register(NAME);
 	if (ret != EOK) {
-		printf("%s: Unable to register driver: %s\n", NAME, str_error(ret));
+		printf("%s: Unable to register driver (%d)\n", NAME, ret);
 		return false;
 	}
@@ -197,5 +196,5 @@
 
 /** Get device block size. */
-static errno_t rd_get_block_size(bd_srv_t *bd, size_t *rsize)
+static int rd_get_block_size(bd_srv_t *bd, size_t *rsize)
 {
 	*rsize = block_size;
@@ -204,5 +203,5 @@
 
 /** Get number of blocks on device. */
-static errno_t rd_get_num_blocks(bd_srv_t *bd, aoff64_t *rnb)
+static int rd_get_num_blocks(bd_srv_t *bd, aoff64_t *rnb)
 {
 	*rnb = rd_size / block_size;
Index: uspace/srv/bd/sata_bd/sata_bd.c
===================================================================
--- uspace/srv/bd/sata_bd/sata_bd.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/bd/sata_bd/sata_bd.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,4 @@
 #include <devman.h>
 #include <errno.h>
-#include <str_error.h>
 #include <stdio.h>
 #include <str.h>
@@ -60,10 +59,10 @@
 static int disk_count;
 
-static errno_t sata_bd_open(bd_srvs_t *, bd_srv_t *);
-static errno_t sata_bd_close(bd_srv_t *);
-static errno_t sata_bd_read_blocks(bd_srv_t *, aoff64_t, size_t, void *, size_t);
-static errno_t sata_bd_write_blocks(bd_srv_t *, aoff64_t, size_t, const void *, size_t);
-static errno_t sata_bd_get_block_size(bd_srv_t *, size_t *);
-static errno_t sata_bd_get_num_blocks(bd_srv_t *, aoff64_t *);
+static int sata_bd_open(bd_srvs_t *, bd_srv_t *);
+static int sata_bd_close(bd_srv_t *);
+static int sata_bd_read_blocks(bd_srv_t *, aoff64_t, size_t, void *, size_t);
+static int sata_bd_write_blocks(bd_srv_t *, aoff64_t, size_t, const void *, size_t);
+static int sata_bd_get_block_size(bd_srv_t *, size_t *);
+static int sata_bd_get_num_blocks(bd_srv_t *, aoff64_t *);
 
 static bd_ops_t sata_bd_ops = {
@@ -88,10 +87,10 @@
  *
  */
-static errno_t scan_device_tree(devman_handle_t funh)
+static int scan_device_tree(devman_handle_t funh)
 {
 	devman_handle_t devh;
 	devman_handle_t *cfuns;
 	size_t count, i;
-	errno_t rc;
+	int rc;
 		
 	/* If device is SATA, add device to the disk array. */
@@ -148,8 +147,8 @@
  *
  */
-static errno_t get_sata_disks(void)
+static int get_sata_disks(void)
 {
 	devman_handle_t root_fun;
-	errno_t rc;
+	int rc;
 	
 	disk_count = 0;
@@ -190,5 +189,5 @@
 
 /** Open device. */
-static errno_t sata_bd_open(bd_srvs_t *bds, bd_srv_t *bd)
+static int sata_bd_open(bd_srvs_t *bds, bd_srv_t *bd)
 {
 	return EOK;
@@ -196,5 +195,5 @@
 
 /** Close device. */
-static errno_t sata_bd_close(bd_srv_t *bd)
+static int sata_bd_close(bd_srv_t *bd)
 {
 	return EOK;
@@ -202,5 +201,5 @@
 
 /** Read blocks from partition. */
-static errno_t sata_bd_read_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt, void *buf,
+static int sata_bd_read_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt, void *buf,
     size_t size)
 {
@@ -214,5 +213,5 @@
 
 /** Write blocks to partition. */
-static errno_t sata_bd_write_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt,
+static int sata_bd_write_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt,
     const void *buf, size_t size)
 {
@@ -226,5 +225,5 @@
 
 /** Get device block size. */
-static errno_t sata_bd_get_block_size(bd_srv_t *bd, size_t *rsize)
+static int sata_bd_get_block_size(bd_srv_t *bd, size_t *rsize)
 {
 	sata_bd_dev_t *sbd = bd_srv_sata(bd);
@@ -235,5 +234,5 @@
 
 /** Get number of blocks on device. */
-static errno_t sata_bd_get_num_blocks(bd_srv_t *bd, aoff64_t *rnb)
+static int sata_bd_get_num_blocks(bd_srv_t *bd, aoff64_t *rnb)
 {
 	sata_bd_dev_t *sbd = bd_srv_sata(bd);
@@ -246,11 +245,11 @@
 int main(int argc, char **argv)
 {
-	errno_t rc;
+	int rc;
 	category_id_t disk_cat;
 	
 	async_set_fallback_port_handler(sata_bd_connection, NULL);
 	rc = loc_server_register(NAME);
-	if (rc != EOK) {
-		printf(NAME ": Unable to register driver: %s.\n", str_error(rc));
+	if (rc < 0) {
+		printf(NAME ": Unable to register driver.\n");
 		return rc;
 	}
@@ -258,5 +257,4 @@
 	rc = get_sata_disks();
 	if (rc != EOK) {
-		// TODO: log the error
 		return rc;
 	}
@@ -264,5 +262,5 @@
 	rc = loc_category_get_id("disk", &disk_cat, IPC_FLAG_BLOCKING);
 	if (rc != EOK) {
-		printf("%s: Failed resolving category 'disk': %s.\n", NAME, str_error(rc));
+		printf("%s: Failed resolving category 'disk'.\n", NAME);
 		return rc;
 	}
@@ -273,5 +271,5 @@
 		rc = loc_service_register(name, &disk[i].service_id);
 		if (rc != EOK) {
-			printf(NAME ": Unable to register device %s: %s\n", name, str_error(rc));
+			printf(NAME ": Unable to register device %s.\n", name);
 			return rc;
 		}
@@ -279,6 +277,6 @@
 		rc = loc_service_add_to_cat(disk[i].service_id, disk_cat);
 		if (rc != EOK) {
-			printf("%s: Failed adding %s to category: %s.",
-			    NAME, disk[i].dev_name, str_error(rc));
+			printf("%s: Failed adding %s to category.",
+			    NAME, disk[i].dev_name);
 			return rc;
 		}
Index: uspace/srv/bd/vbd/disk.c
===================================================================
--- uspace/srv/bd/vbd/disk.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/bd/vbd/disk.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,4 @@
 #include <block.h>
 #include <errno.h>
-#include <str_error.h>
 #include <io/log.h>
 #include <label/empty.h>
@@ -58,28 +57,28 @@
 static category_id_t part_cid;
 
-static errno_t vbds_disk_parts_add(vbds_disk_t *, label_t *);
-static errno_t vbds_disk_parts_remove(vbds_disk_t *, vbds_rem_flag_t);
-
-static errno_t vbds_bd_open(bd_srvs_t *, bd_srv_t *);
-static errno_t vbds_bd_close(bd_srv_t *);
-static errno_t vbds_bd_read_blocks(bd_srv_t *, aoff64_t, size_t, void *, size_t);
-static errno_t vbds_bd_sync_cache(bd_srv_t *, aoff64_t, size_t);
-static errno_t vbds_bd_write_blocks(bd_srv_t *, aoff64_t, size_t, const void *,
+static int vbds_disk_parts_add(vbds_disk_t *, label_t *);
+static int vbds_disk_parts_remove(vbds_disk_t *, vbds_rem_flag_t);
+
+static int vbds_bd_open(bd_srvs_t *, bd_srv_t *);
+static int vbds_bd_close(bd_srv_t *);
+static int vbds_bd_read_blocks(bd_srv_t *, aoff64_t, size_t, void *, size_t);
+static int vbds_bd_sync_cache(bd_srv_t *, aoff64_t, size_t);
+static int vbds_bd_write_blocks(bd_srv_t *, aoff64_t, size_t, const void *,
     size_t);
-static errno_t vbds_bd_get_block_size(bd_srv_t *, size_t *);
-static errno_t vbds_bd_get_num_blocks(bd_srv_t *, aoff64_t *);
-
-static errno_t vbds_bsa_translate(vbds_part_t *, aoff64_t, size_t, aoff64_t *);
-
-static errno_t vbds_part_svc_register(vbds_part_t *);
-static errno_t vbds_part_svc_unregister(vbds_part_t *);
-static errno_t vbds_part_indices_update(vbds_disk_t *);
+static int vbds_bd_get_block_size(bd_srv_t *, size_t *);
+static int vbds_bd_get_num_blocks(bd_srv_t *, aoff64_t *);
+
+static int vbds_bsa_translate(vbds_part_t *, aoff64_t, size_t, aoff64_t *);
+
+static int vbds_part_svc_register(vbds_part_t *);
+static int vbds_part_svc_unregister(vbds_part_t *);
+static int vbds_part_indices_update(vbds_disk_t *);
 
 static vbd_part_id_t vbds_part_id = 1;
 
-static errno_t vbds_label_get_bsize(void *, size_t *);
-static errno_t vbds_label_get_nblocks(void *, aoff64_t *);
-static errno_t vbds_label_read(void *, aoff64_t, size_t, void *);
-static errno_t vbds_label_write(void *, aoff64_t, size_t, const void *);
+static int vbds_label_get_bsize(void *, size_t *);
+static int vbds_label_get_nblocks(void *, aoff64_t *);
+static int vbds_label_read(void *, aoff64_t, size_t, void *);
+static int vbds_label_write(void *, aoff64_t, size_t, const void *);
 
 /** Block device operations provided by VBD */
@@ -132,7 +131,7 @@
 }
 
-errno_t vbds_disks_init(void)
-{
-	errno_t rc;
+int vbds_disks_init(void)
+{
+	int rc;
 
 	fibril_mutex_initialize(&vbds_disks_lock);
@@ -152,5 +151,5 @@
 
 /** Check for new/removed disk devices */
-static errno_t vbds_disks_check_new(void)
+static int vbds_disks_check_new(void)
 {
 	bool already_known;
@@ -159,5 +158,5 @@
 	size_t count, i;
 	vbds_disk_t *cur, *next;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_disks_check_new()");
@@ -229,5 +228,5 @@
 
 
-static errno_t vbds_disk_by_svcid(service_id_t sid, vbds_disk_t **rdisk)
+static int vbds_disk_by_svcid(service_id_t sid, vbds_disk_t **rdisk)
 {
 	list_foreach(vbds_disks, ldisks, vbds_disk_t, disk) {
@@ -256,5 +255,5 @@
 }
 
-static errno_t vbds_part_by_pid(vbds_part_id_t partid, vbds_part_t **rpart)
+static int vbds_part_by_pid(vbds_part_id_t partid, vbds_part_t **rpart)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_by_pid(%zu)", partid);
@@ -278,5 +277,5 @@
 }
 
-static errno_t vbds_part_by_svcid(service_id_t svcid, vbds_part_t **rpart)
+static int vbds_part_by_svcid(service_id_t svcid, vbds_part_t **rpart)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_by_svcid(%zu)", svcid);
@@ -301,5 +300,5 @@
 
 /** Add partition to our inventory based on liblabel partition structure */
-static errno_t vbds_part_add(vbds_disk_t *disk, label_part_t *lpart,
+static int vbds_part_add(vbds_disk_t *disk, label_part_t *lpart,
     vbds_part_t **rpart)
 {
@@ -307,5 +306,5 @@
 	service_id_t psid = 0;
 	label_part_info_t lpinfo;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_add(%s, %p)",
@@ -362,9 +361,9 @@
  *
  */
-static errno_t vbds_part_remove(vbds_part_t *part, vbds_rem_flag_t flag,
+static int vbds_part_remove(vbds_part_t *part, vbds_rem_flag_t flag,
     label_part_t **rlpart)
 {
 	label_part_t *lpart;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_remove(%p)", part);
@@ -404,8 +403,8 @@
 /** Remove all disk partitions from our inventory leaving only the underlying
  * liblabel partition structures. */
-static errno_t vbds_disk_parts_add(vbds_disk_t *disk, label_t *label)
+static int vbds_disk_parts_add(vbds_disk_t *disk, label_t *label)
 {
 	label_part_t *part;
-	errno_t rc;
+	int rc;
 
 	part = label_part_first(label);
@@ -426,9 +425,9 @@
 /** Remove all disk partitions from our inventory leaving only the underlying
  * liblabel partition structures. */
-static errno_t vbds_disk_parts_remove(vbds_disk_t *disk, vbds_rem_flag_t flag)
+static int vbds_disk_parts_remove(vbds_disk_t *disk, vbds_rem_flag_t flag)
 {
 	link_t *link;
 	vbds_part_t *part;
-	errno_t rc;
+	int rc;
 
 	link = list_first(&disk->parts);
@@ -450,12 +449,12 @@
 }
 
-errno_t vbds_disk_discovery_start(void)
-{
-	errno_t rc;
+int vbds_disk_discovery_start(void)
+{
+	int rc;
 
 	rc = loc_register_cat_change_cb(vbds_disk_cat_change_cb);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering callback "
-		    "for disk discovery: %s.", str_error(rc));
+		    "for disk discovery (%d).", rc);
 		return rc;
 	}
@@ -464,5 +463,5 @@
 }
 
-errno_t vbds_disk_add(service_id_t sid)
+int vbds_disk_add(service_id_t sid)
 {
 	label_t *label = NULL;
@@ -472,5 +471,5 @@
 	size_t block_size;
 	aoff64_t nblocks;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_disk_add(%zu)", sid);
@@ -557,8 +556,8 @@
 }
 
-errno_t vbds_disk_remove(service_id_t sid)
+int vbds_disk_remove(service_id_t sid)
 {
 	vbds_disk_t *disk;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_disk_remove(%zu)", sid);
@@ -583,5 +582,5 @@
 
 /** Get list of disks as array of service IDs. */
-errno_t vbds_disk_get_ids(service_id_t *id_buf, size_t buf_size, size_t *act_size)
+int vbds_disk_get_ids(service_id_t *id_buf, size_t buf_size, size_t *act_size)
 {
 	size_t act_cnt;
@@ -611,9 +610,9 @@
 }
 
-errno_t vbds_disk_info(service_id_t sid, vbd_disk_info_t *info)
+int vbds_disk_info(service_id_t sid, vbd_disk_info_t *info)
 {
 	vbds_disk_t *disk;
 	label_info_t linfo;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_disk_info(%zu)", sid);
@@ -638,5 +637,5 @@
 }
 
-errno_t vbds_get_parts(service_id_t sid, service_id_t *id_buf, size_t buf_size,
+int vbds_get_parts(service_id_t sid, service_id_t *id_buf, size_t buf_size,
     size_t *act_size)
 {
@@ -644,5 +643,5 @@
 	size_t act_cnt;
 	size_t buf_cnt;
-	errno_t rc;
+	int rc;
 
 	rc = vbds_disk_by_svcid(sid, &disk);
@@ -668,5 +667,5 @@
 }
 
-errno_t vbds_label_create(service_id_t sid, label_type_t ltype)
+int vbds_label_create(service_id_t sid, label_type_t ltype)
 {
 	label_t *label;
@@ -674,5 +673,5 @@
 	label_info_t linfo;
 	vbds_disk_t *disk;
-	errno_t rc, rc2;
+	int rc, rc2;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_label_create(%zu)", sid);
@@ -739,10 +738,10 @@
 }
 
-errno_t vbds_label_delete(service_id_t sid)
+int vbds_label_delete(service_id_t sid)
 {
 	vbds_disk_t *disk;
 	label_t *label;
 	label_bd_t lbd;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_label_delete(%zu)", sid);
@@ -781,9 +780,9 @@
 }
 
-errno_t vbds_part_get_info(vbds_part_id_t partid, vbd_part_info_t *pinfo)
+int vbds_part_get_info(vbds_part_id_t partid, vbd_part_info_t *pinfo)
 {
 	vbds_part_t *part;
 	label_part_info_t lpinfo;
-	errno_t rc;
+	int rc;
 
 	rc = vbds_part_by_pid(partid, &part);
@@ -810,5 +809,5 @@
 }
 
-errno_t vbds_part_create(service_id_t sid, vbd_part_spec_t *pspec,
+int vbds_part_create(service_id_t sid, vbd_part_spec_t *pspec,
     vbds_part_id_t *rpart)
 {
@@ -817,5 +816,5 @@
 	label_part_spec_t lpspec;
 	label_part_t *lpart;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_create(%zu)", sid);
@@ -879,10 +878,10 @@
 }
 
-errno_t vbds_part_delete(vbds_part_id_t partid)
+int vbds_part_delete(vbds_part_id_t partid)
 {
 	vbds_part_t *part;
 	vbds_disk_t *disk;
 	label_part_t *lpart;
-	errno_t rc;
+	int rc;
 
 	rc = vbds_part_by_pid(partid, &part);
@@ -918,9 +917,9 @@
 }
 
-errno_t vbds_suggest_ptype(service_id_t sid, label_pcnt_t pcnt,
+int vbds_suggest_ptype(service_id_t sid, label_pcnt_t pcnt,
     label_ptype_t *ptype)
 {
 	vbds_disk_t *disk;
-	errno_t rc;
+	int rc;
 
 	rc = vbds_disk_by_svcid(sid, &disk);
@@ -942,5 +941,5 @@
 }
 
-static errno_t vbds_bd_open(bd_srvs_t *bds, bd_srv_t *bd)
+static int vbds_bd_open(bd_srvs_t *bds, bd_srv_t *bd)
 {
 	vbds_part_t *part = bd_srv_part(bd);
@@ -953,5 +952,5 @@
 }
 
-static errno_t vbds_bd_close(bd_srv_t *bd)
+static int vbds_bd_close(bd_srv_t *bd)
 {
 	vbds_part_t *part = bd_srv_part(bd);
@@ -967,10 +966,10 @@
 }
 
-static errno_t vbds_bd_read_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt,
+static int vbds_bd_read_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt,
     void *buf, size_t size)
 {
 	vbds_part_t *part = bd_srv_part(bd);
 	aoff64_t gba;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG2, "vbds_bd_read_blocks()");
@@ -993,9 +992,9 @@
 }
 
-static errno_t vbds_bd_sync_cache(bd_srv_t *bd, aoff64_t ba, size_t cnt)
+static int vbds_bd_sync_cache(bd_srv_t *bd, aoff64_t ba, size_t cnt)
 {
 	vbds_part_t *part = bd_srv_part(bd);
 	aoff64_t gba;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG2, "vbds_bd_sync_cache()");
@@ -1017,10 +1016,10 @@
 }
 
-static errno_t vbds_bd_write_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt,
+static int vbds_bd_write_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt,
     const void *buf, size_t size)
 {
 	vbds_part_t *part = bd_srv_part(bd);
 	aoff64_t gba;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG2, "vbds_bd_write_blocks()");
@@ -1042,5 +1041,5 @@
 }
 
-static errno_t vbds_bd_get_block_size(bd_srv_t *bd, size_t *rsize)
+static int vbds_bd_get_block_size(bd_srv_t *bd, size_t *rsize)
 {
 	vbds_part_t *part = bd_srv_part(bd);
@@ -1055,5 +1054,5 @@
 }
 
-static errno_t vbds_bd_get_num_blocks(bd_srv_t *bd, aoff64_t *rnb)
+static int vbds_bd_get_num_blocks(bd_srv_t *bd, aoff64_t *rnb)
 {
 	vbds_part_t *part = bd_srv_part(bd);
@@ -1071,5 +1070,5 @@
 {
 	vbds_part_t *part;
-	errno_t rc;
+	int rc;
 	service_id_t svcid;
 
@@ -1094,5 +1093,5 @@
 
 /** Translate block segment address with range checking. */
-static errno_t vbds_bsa_translate(vbds_part_t *part, aoff64_t ba, size_t cnt,
+static int vbds_bsa_translate(vbds_part_t *part, aoff64_t ba, size_t cnt,
     aoff64_t *gba)
 {
@@ -1105,14 +1104,15 @@
 
 /** Register service for partition */
-static errno_t vbds_part_svc_register(vbds_part_t *part)
+static int vbds_part_svc_register(vbds_part_t *part)
 {
 	char *name;
 	service_id_t psid;
 	int idx;
-	errno_t rc;
+	int rc;
 
 	idx = part->lpart->index;
 
-	if (asprintf(&name, "%sp%u", part->disk->svc_name, idx) < 0) {
+	rc = asprintf(&name, "%sp%u", part->disk->svc_name, idx);
+	if (rc < 0) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Out of memory.");
 		return ENOMEM;
@@ -1124,5 +1124,5 @@
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering "
-		    "service %s: %s.", name, str_error(rc));
+		    "service %s (%d).", name, rc);
 		free(name);
 		free(part);
@@ -1152,7 +1152,7 @@
 
 /** Unregister service for partition */
-static errno_t vbds_part_svc_unregister(vbds_part_t *part)
-{
-	errno_t rc;
+static int vbds_part_svc_unregister(vbds_part_t *part)
+{
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_svc_unregister("
@@ -1169,8 +1169,8 @@
 
 /** Update service names for any partition whose index has changed. */
-static errno_t vbds_part_indices_update(vbds_disk_t *disk)
+static int vbds_part_indices_update(vbds_disk_t *disk)
 {
 	label_part_info_t lpinfo;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_indices_update()");
@@ -1219,5 +1219,5 @@
 
 /** Get block size wrapper for liblabel */
-static errno_t vbds_label_get_bsize(void *arg, size_t *bsize)
+static int vbds_label_get_bsize(void *arg, size_t *bsize)
 {
 	vbds_disk_t *disk = (vbds_disk_t *)arg;
@@ -1226,5 +1226,5 @@
 
 /** Get number of blocks wrapper for liblabel */
-static errno_t vbds_label_get_nblocks(void *arg, aoff64_t *nblocks)
+static int vbds_label_get_nblocks(void *arg, aoff64_t *nblocks)
 {
 	vbds_disk_t *disk = (vbds_disk_t *)arg;
@@ -1233,5 +1233,5 @@
 
 /** Read blocks wrapper for liblabel */
-static errno_t vbds_label_read(void *arg, aoff64_t ba, size_t cnt, void *buf)
+static int vbds_label_read(void *arg, aoff64_t ba, size_t cnt, void *buf)
 {
 	vbds_disk_t *disk = (vbds_disk_t *)arg;
@@ -1240,5 +1240,5 @@
 
 /** Write blocks wrapper for liblabel */
-static errno_t vbds_label_write(void *arg, aoff64_t ba, size_t cnt, const void *data)
+static int vbds_label_write(void *arg, aoff64_t ba, size_t cnt, const void *data)
 {
 	vbds_disk_t *disk = (vbds_disk_t *)arg;
Index: uspace/srv/bd/vbd/disk.h
===================================================================
--- uspace/srv/bd/vbd/disk.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/bd/vbd/disk.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,17 +42,17 @@
 #include <vbd.h>
 
-extern errno_t vbds_disks_init(void);
-extern errno_t vbds_disk_discovery_start(void);
-extern errno_t vbds_disk_add(service_id_t);
-extern errno_t vbds_disk_remove(service_id_t);
-extern errno_t vbds_disk_get_ids(service_id_t *, size_t, size_t *);
-extern errno_t vbds_disk_info(service_id_t, vbd_disk_info_t *);
-extern errno_t vbds_get_parts(service_id_t, service_id_t *, size_t, size_t *);
-extern errno_t vbds_label_create(service_id_t, label_type_t);
-extern errno_t vbds_label_delete(service_id_t);
-extern errno_t vbds_part_get_info(vbds_part_id_t, vbd_part_info_t *);
-extern errno_t vbds_part_create(service_id_t, vbd_part_spec_t *, vbds_part_id_t *);
-extern errno_t vbds_part_delete(vbds_part_id_t);
-extern errno_t vbds_suggest_ptype(service_id_t, label_pcnt_t, label_ptype_t *);
+extern int vbds_disks_init(void);
+extern int vbds_disk_discovery_start(void);
+extern int vbds_disk_add(service_id_t);
+extern int vbds_disk_remove(service_id_t);
+extern int vbds_disk_get_ids(service_id_t *, size_t, size_t *);
+extern int vbds_disk_info(service_id_t, vbd_disk_info_t *);
+extern int vbds_get_parts(service_id_t, service_id_t *, size_t, size_t *);
+extern int vbds_label_create(service_id_t, label_type_t);
+extern int vbds_label_delete(service_id_t);
+extern int vbds_part_get_info(vbds_part_id_t, vbd_part_info_t *);
+extern int vbds_part_create(service_id_t, vbd_part_spec_t *,vbds_part_id_t *);
+extern int vbds_part_delete(vbds_part_id_t);
+extern int vbds_suggest_ptype(service_id_t, label_pcnt_t, label_ptype_t *);
 extern void vbds_bd_conn(ipc_callid_t, ipc_call_t *, void *);
 
Index: uspace/srv/bd/vbd/vbd.c
===================================================================
--- uspace/srv/bd/vbd/vbd.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/bd/vbd/vbd.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #include <async.h>
 #include <errno.h>
-#include <str_error.h>
 #include <io/log.h>
 #include <ipc/services.h>
@@ -57,7 +56,7 @@
 static service_id_t ctl_sid;
 
-static errno_t vbds_init(void)
-{
-	errno_t rc;
+static int vbds_init(void)
+{
+	int rc;
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_init()");
 
@@ -70,5 +69,5 @@
 	rc = loc_server_register(NAME);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server: %s.", str_error(rc));
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server (%d).", rc);
 		return EEXIST;
 	}
@@ -76,5 +75,5 @@
 	rc = loc_service_register(SERVICE_NAME_VBD, &ctl_sid);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service: %s.", str_error(rc));
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service (%d).", rc);
 		return EEXIST;
 	}
@@ -92,5 +91,5 @@
 	size_t size;
 	size_t act_size;
-	errno_t rc;
+	int rc;
 
 	if (!async_data_read_receive(&callid, &size)) {
@@ -115,5 +114,5 @@
 	}
 
-	errno_t retval = async_data_read_finalize(callid, id_buf, size);
+	sysarg_t retval = async_data_read_finalize(callid, id_buf, size);
 	free(id_buf);
 
@@ -125,5 +124,5 @@
 	service_id_t disk_sid;
 	vbd_disk_info_t dinfo;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_disk_info_srv()");
@@ -165,5 +164,5 @@
 	service_id_t disk_sid;
 	label_type_t ltype;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_label_create_srv()");
@@ -172,5 +171,5 @@
 	ltype = IPC_GET_ARG2(*icall);
 	rc = vbds_label_create(disk_sid, ltype);
-	async_answer_0(iid, rc);
+	async_answer_0(iid, (sysarg_t) rc);
 }
 
@@ -178,5 +177,5 @@
 {
 	service_id_t disk_sid;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_label_delete_srv()");
@@ -184,5 +183,5 @@
 	disk_sid = IPC_GET_ARG1(*icall);
 	rc = vbds_label_delete(disk_sid);
-	async_answer_0(iid, rc);
+	async_answer_0(iid, (sysarg_t) rc);
 }
 
@@ -193,5 +192,5 @@
 	size_t act_size;
 	service_id_t sid;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_label_get_parts_srv()");
@@ -219,5 +218,5 @@
 	}
 
-	errno_t retval = async_data_read_finalize(callid, id_buf, size);
+	sysarg_t retval = async_data_read_finalize(callid, id_buf, size);
 	free(id_buf);
 
@@ -229,5 +228,5 @@
 	vbds_part_id_t part;
 	vbd_part_info_t pinfo;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_get_info_srv()");
@@ -270,5 +269,5 @@
 	vbd_part_spec_t pspec;
 	vbds_part_id_t part;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_create_srv()");
@@ -303,5 +302,5 @@
 	}
 
-	async_answer_1(iid, rc, (sysarg_t)part);
+	async_answer_1(iid, (sysarg_t)rc, (sysarg_t)part);
 }
 
@@ -309,5 +308,5 @@
 {
 	vbds_part_id_t part;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_delete_srv()");
@@ -315,5 +314,5 @@
 	part = IPC_GET_ARG1(*icall);
 	rc = vbds_part_delete(part);
-	async_answer_0(iid, rc);
+	async_answer_0(iid, (sysarg_t) rc);
 }
 
@@ -323,5 +322,5 @@
 	label_ptype_t ptype;
 	label_pcnt_t pcnt;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_suggest_ptype_srv()");
@@ -428,5 +427,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 
 	printf("%s: Virtual Block Device service\n", NAME);
Index: uspace/srv/clipboard/clipboard.c
===================================================================
--- uspace/srv/clipboard/clipboard.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/clipboard/clipboard.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -29,5 +29,4 @@
 #include <async.h>
 #include <errno.h>
-#include <str_error.h>
 #include <fibril_synch.h>
 #include <ipc/services.h>
@@ -50,5 +49,5 @@
 {
 	char *data;
-	errno_t rc;
+	int rc;
 	size_t size;
 	
@@ -121,5 +120,5 @@
 		}
 		
-		errno_t retval = async_data_read_finalize(callid, clip_data, size);
+		sysarg_t retval = async_data_read_finalize(callid, clip_data, size);
 		if (retval != EOK) {
 			async_answer_0(rid, retval);
@@ -182,5 +181,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 	
 	printf("%s: HelenOS clipboard service\n", NAME);
@@ -189,5 +188,5 @@
 	rc = loc_server_register(NAME);
 	if (rc != EOK) {
-		printf("%s: Failed registering server: %s\n", NAME, str_error(rc));
+		printf("%s: Failed registering server. (%d)\n", NAME, rc);
 		return rc;
 	}
@@ -195,5 +194,5 @@
 	rc = loc_service_register(SERVICE_NAME_CLIPBOARD, &svc_id);
 	if (rc != EOK) {
-		printf("%s: Failed registering service : %s\n", NAME, str_error(rc));
+		printf("%s: Failed registering service. (%d)\n", NAME, rc);
 		return rc;
 	}
